import { HTMLProps } from 'react'
import { useRecoilValue } from 'recoil'
import styled from 'styled-components'
import { UserSettings } from '../data/user/settings'
import { SessionValue, SiteTheme } from '../globals/state'
import { Gradient } from '../styles/animations'
import { LoadingBarInnerAnimate, LoadingBarInner } from '../styles/components/conversation'
import { LoginBackground } from '../styles/components/login'
import Spinner from './spinner'

export const LoadingSpinner = styled(Spinner)`
    width: 30px;
    height: 30px;
`

export default function Loading(): JSX.Element {
    return (
        <LoginBackground>
            <LoadingSpinner visible={true} />
        </LoginBackground>
    )
}

export const LoadingBar: React.FC<{visible: boolean; progress: number, className?: string} & HTMLProps<any>> = ({
    visible,
    progress,
    style = {},
    ...props
}) => {
    return (
        <div
            style={{
                height: '1px',
                position: 'relative',
                ...style
            }}
            {...props}
        >
            {progress === 0 ? (
                <LoadingBarInnerAnimate visible={visible} />
            ) : (
                <LoadingBarInner visible={visible} style={{ width: progress + '%' }} />
            )}
        </div>
    )
}